/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1beta2

import (
	"context"
	"time"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	scheme "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-aws/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AWSMachineTemplatesGetter has a method to return a AWSMachineTemplateInterface.
// A group's client should implement this interface.
type AWSMachineTemplatesGetter interface {
	AWSMachineTemplates(namespace string) AWSMachineTemplateInterface
}

// AWSMachineTemplateInterface has methods to work with AWSMachineTemplate resources.
type AWSMachineTemplateInterface interface {
	Create(ctx context.Context, aWSMachineTemplate *v1beta2.AWSMachineTemplate, opts v1.CreateOptions) (*v1beta2.AWSMachineTemplate, error)
	Update(ctx context.Context, aWSMachineTemplate *v1beta2.AWSMachineTemplate, opts v1.UpdateOptions) (*v1beta2.AWSMachineTemplate, error)
	UpdateStatus(ctx context.Context, aWSMachineTemplate *v1beta2.AWSMachineTemplate, opts v1.UpdateOptions) (*v1beta2.AWSMachineTemplate, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta2.AWSMachineTemplate, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta2.AWSMachineTemplateList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSMachineTemplate, err error)
	AWSMachineTemplateExpansion
}

// aWSMachineTemplates implements AWSMachineTemplateInterface
type aWSMachineTemplates struct {
	client rest.Interface
	ns     string
}

// newAWSMachineTemplates returns a AWSMachineTemplates
func newAWSMachineTemplates(c *InfrastructureV1beta2Client, namespace string) *aWSMachineTemplates {
	return &aWSMachineTemplates{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the aWSMachineTemplate, and returns the corresponding aWSMachineTemplate object, and an error if there is any.
func (c *aWSMachineTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSMachineTemplate, err error) {
	result = &v1beta2.AWSMachineTemplate{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AWSMachineTemplates that match those selectors.
func (c *aWSMachineTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSMachineTemplateList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta2.AWSMachineTemplateList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested aWSMachineTemplates.
func (c *aWSMachineTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a aWSMachineTemplate and creates it.  Returns the server's representation of the aWSMachineTemplate, and an error, if there is any.
func (c *aWSMachineTemplates) Create(ctx context.Context, aWSMachineTemplate *v1beta2.AWSMachineTemplate, opts v1.CreateOptions) (result *v1beta2.AWSMachineTemplate, err error) {
	result = &v1beta2.AWSMachineTemplate{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSMachineTemplate).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a aWSMachineTemplate and updates it. Returns the server's representation of the aWSMachineTemplate, and an error, if there is any.
func (c *aWSMachineTemplates) Update(ctx context.Context, aWSMachineTemplate *v1beta2.AWSMachineTemplate, opts v1.UpdateOptions) (result *v1beta2.AWSMachineTemplate, err error) {
	result = &v1beta2.AWSMachineTemplate{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		Name(aWSMachineTemplate.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSMachineTemplate).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *aWSMachineTemplates) UpdateStatus(ctx context.Context, aWSMachineTemplate *v1beta2.AWSMachineTemplate, opts v1.UpdateOptions) (result *v1beta2.AWSMachineTemplate, err error) {
	result = &v1beta2.AWSMachineTemplate{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		Name(aWSMachineTemplate.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSMachineTemplate).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the aWSMachineTemplate and deletes it. Returns an error if one occurs.
func (c *aWSMachineTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *aWSMachineTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched aWSMachineTemplate.
func (c *aWSMachineTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSMachineTemplate, err error) {
	result = &v1beta2.AWSMachineTemplate{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("awsmachinetemplates").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
